#pragma once
#include "molasses/parser_primitives.h"

namespace molasses {
	std::vector<std::string> initialize_stack();
	
	std::vector<std::string> generate_return();
	
	std::vector<std::string> generate_label(const std::string& target);
	
    std::vector<std::string> generate_push_int32(int32_t target);

    std::vector<std::string> generate_push_int64(int64_t target);
	
	std::vector<std::string> generate_call(const std::string& target);
	
	std::vector<std::string> generate_enter();

    std::vector<std::string> generate_push_string_ptr(const symbol&);

    std::vector<std::string> generate_string(const symbol&, const std::string&);
}